Index: trunk/source/processes/hadronic/models/qmd/src/G4QMDReaction.cc
===================================================================
--- trunk/source/processes/hadronic/models/qmd/src/G4QMDReaction.cc	(revision 1007)
+++ trunk/source/processes/hadronic/models/qmd/src/G4QMDReaction.cc	(revision 1055)
@@ -31,4 +31,6 @@
 //            UseFrag (chage criterion of a inelastic reaction)
 //        Fix bug in nucleon projectiles  by T. Koi    
+// 090122 Be8 -> Alpha + Alpha 
+// 090331 Change member shenXS and genspaXS object to pointer 
 //
 #include "G4QMDReaction.hh"
@@ -45,4 +47,8 @@
 , frag ( false )
 {
+
+   //090331
+   shenXS = new G4IonsShenCrossSection();
+   //genspaXS = new G4GeneralSpaceNNCrossSection();
    meanField = new G4QMDMeanField();
    collision = new G4QMDCollision();
@@ -99,6 +105,7 @@
      G4double aTemp = projectile.GetMaterial()->GetTemperature();
 
-     //G4double xs_0 = shenXS.GetCrossSection ( proj_dp , targ_ele , aTemp );
-     G4double xs_0 = genspaXS.GetCrossSection ( proj_dp , targ_ele , aTemp );
+     //090331
+     G4double xs_0 = shenXS->GetCrossSection ( proj_dp , targ_ele , aTemp );
+     //G4double xs_0 = genspaXS->GetCrossSection ( proj_dp , targ_ele , aTemp );
      G4double bmax_0 = std::sqrt( xs_0 / pi );
      //std::cout << "bmax_0 in fm (fermi) " <<  bmax_0/fermi << std::endl;
@@ -470,10 +477,42 @@
           // Secondary from this nucleus (*it) 
           G4ParticleDefinition* pd = (*itt)->GetDefinition();
+
           G4LorentzVector p4 ( (*itt)->GetMomentum()/GeV , (*itt)->GetTotalEnergy()/GeV );  //in nucleus(*it) rest system
           G4LorentzVector p4_CM = CLHEP::boostOf( p4 , -nucleus_p4CM.findBoostToCM() );  // Back to CM
           G4LorentzVector p4_LAB = CLHEP::boostOf( p4_CM , boostBackToLAB ); // Back to LAB  
 
-          G4DynamicParticle* dp = new G4DynamicParticle( pd , p4_LAB*GeV );  
-          theParticleChange.AddSecondary( dp ); 
+
+//090122
+          //theParticleChange.AddSecondary( dp ); 
+          if ( !( pd->GetAtomicNumber() == 4 && pd->GetAtomicMass() == 8 ) )
+          {
+             G4DynamicParticle* dp = new G4DynamicParticle( pd , p4_LAB*GeV );  
+             theParticleChange.AddSecondary( dp ); 
+          }
+          else
+          {
+             //Be8 -> Alpha + Alpha + Q
+             G4ThreeVector randomized_direction( G4UniformRand() , G4UniformRand() , G4UniformRand() );
+             randomized_direction = randomized_direction.unit();
+             G4double q_decay = (*itt)->GetMass() - 2*G4Alpha::Alpha()->GetPDGMass();
+             G4double p_decay = std::sqrt ( std::pow(G4Alpha::Alpha()->GetPDGMass()+q_decay/2,2) - std::pow(G4Alpha::Alpha()->GetPDGMass() , 2 ) ); 
+             G4LorentzVector p4_a1 ( p_decay*randomized_direction , G4Alpha::Alpha()->GetPDGMass()+q_decay/2 );  //in Be8 rest system
+             
+             G4LorentzVector p4_a1_Be8 = CLHEP::boostOf ( p4_a1/GeV , -p4.findBoostToCM() );
+             G4LorentzVector p4_a1_CM = CLHEP::boostOf ( p4_a1_Be8 , -nucleus_p4CM.findBoostToCM() );
+             G4LorentzVector p4_a1_LAB = CLHEP::boostOf ( p4_a1_CM , boostBackToLAB );
+
+             G4LorentzVector p4_a2 ( -p_decay*randomized_direction , G4Alpha::Alpha()->GetPDGMass()+q_decay/2 );  //in Be8 rest system
+             
+             G4LorentzVector p4_a2_Be8 = CLHEP::boostOf ( p4_a2/GeV , -p4.findBoostToCM() );
+             G4LorentzVector p4_a2_CM = CLHEP::boostOf ( p4_a2_Be8 , -nucleus_p4CM.findBoostToCM() );
+             G4LorentzVector p4_a2_LAB = CLHEP::boostOf ( p4_a2_CM , boostBackToLAB );
+             
+             G4DynamicParticle* dp1 = new G4DynamicParticle( G4Alpha::Alpha() , p4_a1_LAB*GeV );  
+             G4DynamicParticle* dp2 = new G4DynamicParticle( G4Alpha::Alpha() , p4_a2_LAB*GeV );  
+             theParticleChange.AddSecondary( dp1 ); 
+             theParticleChange.AddSecondary( dp2 ); 
+          }
+//090122
 
 /*
@@ -698,3 +737,2 @@
 
 }
-
Index: trunk/source/processes/hadronic/models/rpg/History
===================================================================
--- trunk/source/processes/hadronic/models/rpg/History	(revision 1007)
+++ trunk/source/processes/hadronic/models/rpg/History	(revision 1055)
@@ -15,4 +15,10 @@
    ---------------------------------------------------------------
 
+25 May 2009 - Dennis Wright (hadr-rpg-V09-02-00)
+------------------------------------------------
+G4RPGInelastic:  fix MAC complaint about initialization order:
+   remove static array of G4ParticleDefinition pointers and
+   replace with local array 
+  
  9 June 2008 - Dennis Wright (hadr-rpg-V09-01-03)
 -------------------------------------------------
Index: trunk/source/processes/hadronic/models/rpg/include/G4RPGInelastic.hh
===================================================================
--- trunk/source/processes/hadronic/models/rpg/include/G4RPGInelastic.hh	(revision 1007)
+++ trunk/source/processes/hadronic/models/rpg/include/G4RPGInelastic.hh	(revision 1055)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4RPGInelastic.hh,v 1.3 2008/02/22 22:17:25 dennis Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4RPGInelastic.hh,v 1.4 2009/05/25 19:06:59 dennis Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 // Author: D. H. Wright
@@ -55,7 +55,5 @@
  public:  // with description
     
-   G4RPGInelastic(const G4String& modelName = "RPGInelastic") 
-    : G4HadronicInteraction(modelName)
-   { cache = 0.0;}
+   G4RPGInelastic(const G4String& modelName = "RPGInelastic"); 
     
    virtual ~G4RPGInelastic()
@@ -124,5 +122,7 @@
          lam, sp, s0, sm, xi0, xim, om, ap, an};
 
-   static G4ParticleDefinition* particleDef[18];
+ protected:
+
+   G4ParticleDefinition* particleDef[18];
 
  private:
Index: trunk/source/processes/hadronic/models/rpg/include/G4RPGNucleonInelastic.hh
===================================================================
--- trunk/source/processes/hadronic/models/rpg/include/G4RPGNucleonInelastic.hh	(revision 1007)
+++ trunk/source/processes/hadronic/models/rpg/include/G4RPGNucleonInelastic.hh	(revision 1055)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4RPGNucleonInelastic.hh,v 1.1 2008/01/04 23:27:45 dennis Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4RPGNucleonInelastic.hh,v 1.2 2009/05/25 19:05:19 dennis Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 // Author: D. H. Wright
@@ -48,4 +48,6 @@
     
    ~G4RPGNucleonInelastic() { }
+
+   //   void printCrossSections() const;
     
  protected:
Index: trunk/source/processes/hadronic/models/rpg/include/G4RPGPionInelastic.hh
===================================================================
--- trunk/source/processes/hadronic/models/rpg/include/G4RPGPionInelastic.hh	(revision 1007)
+++ trunk/source/processes/hadronic/models/rpg/include/G4RPGPionInelastic.hh	(revision 1055)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4RPGPionInelastic.hh,v 1.1 2008/01/05 00:14:03 dennis Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4RPGPionInelastic.hh,v 1.2 2009/05/25 19:05:34 dennis Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 // Author: D. H. Wright
@@ -48,4 +48,6 @@
     
    ~G4RPGPionInelastic() { }
+
+   //   void printCrossSections() const;
     
  protected:
Index: trunk/source/processes/hadronic/models/rpg/src/G4RPGInelastic.cc
===================================================================
--- trunk/source/processes/hadronic/models/rpg/src/G4RPGInelastic.cc	(revision 1007)
+++ trunk/source/processes/hadronic/models/rpg/src/G4RPGInelastic.cc	(revision 1055)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4RPGInelastic.cc,v 1.6 2008/03/22 00:03:24 dennis Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4RPGInelastic.cc,v 1.7 2009/05/25 19:07:15 dennis Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 
@@ -34,5 +34,30 @@
 #include "G4RPGTwoBody.hh"
 
- 
+
+G4RPGInelastic::G4RPGInelastic(const G4String& modelName)
+  : G4HadronicInteraction(modelName)
+{
+  cache = 0.0;
+  particleDef[0] = G4PionZero::PionZero();
+  particleDef[1] = G4PionPlus::PionPlus();
+  particleDef[2] = G4PionMinus::PionMinus();
+  particleDef[3] = G4KaonPlus::KaonPlus();
+  particleDef[4] = G4KaonMinus::KaonMinus();
+  particleDef[5] = G4KaonZero::KaonZero();
+  particleDef[6] = G4AntiKaonZero::AntiKaonZero();
+  particleDef[7] = G4Proton::Proton();
+  particleDef[8] = G4Neutron::Neutron();
+  particleDef[9] = G4Lambda::Lambda();
+  particleDef[10] = G4SigmaPlus::SigmaPlus();
+  particleDef[11] = G4SigmaZero::SigmaZero();
+  particleDef[12] = G4SigmaMinus::SigmaMinus();
+  particleDef[13] = G4XiZero::XiZero();
+  particleDef[14] = G4XiMinus::XiMinus();
+  particleDef[15] = G4OmegaMinus::OmegaMinus();
+  particleDef[16] = G4AntiProton::AntiProton();
+  particleDef[17] = G4AntiNeutron::AntiNeutron();
+}
+
+
 G4double G4RPGInelastic::Pmltpc(G4int np, G4int nm, G4int nz, 
                                 G4int n, G4double b, G4double c)
@@ -568,26 +593,4 @@
   2.4,  3.2,  4.2,   5.6,   7.5,   10.0,  13.0,  18.0,  24.0, 32.0 };
 
-G4ParticleDefinition* p0 = G4PionZero::PionZero();
-G4ParticleDefinition* p1 = G4PionPlus::PionPlus();
-G4ParticleDefinition* p2 = G4PionMinus::PionMinus();
-G4ParticleDefinition* p3 = G4KaonPlus::KaonPlus();
-G4ParticleDefinition* p4 = G4KaonMinus::KaonMinus();
-G4ParticleDefinition* p5 = G4KaonZero::KaonZero();
-G4ParticleDefinition* p6 = G4AntiKaonZero::AntiKaonZero();
-G4ParticleDefinition* p7 = G4Proton::Proton();
-G4ParticleDefinition* p8 = G4Neutron::Neutron();
-G4ParticleDefinition* p9 = G4Lambda::Lambda();
-G4ParticleDefinition* p10 = G4SigmaPlus::SigmaPlus();
-G4ParticleDefinition* p11 = G4SigmaZero::SigmaZero();
-G4ParticleDefinition* p12 = G4SigmaMinus::SigmaMinus();
-G4ParticleDefinition* p13 = G4XiZero::XiZero();
-G4ParticleDefinition* p14 = G4XiMinus::XiMinus();
-G4ParticleDefinition* p15 = G4OmegaMinus::OmegaMinus();
-G4ParticleDefinition* p16 = G4AntiProton::AntiProton();
-G4ParticleDefinition* p17 = G4AntiNeutron::AntiNeutron();
-
-G4ParticleDefinition* G4RPGInelastic::particleDef[18] = {
-  p0, p1, p2, p3, p4, p5, p6, p7, p8, p9, p10, p11, p12, p13, p14, 
-  p15, p16, p17 };
 
 /* end of file */
Index: trunk/source/processes/hadronic/models/rpg/src/G4RPGNucleonInelastic.cc
===================================================================
--- trunk/source/processes/hadronic/models/rpg/src/G4RPGNucleonInelastic.cc	(revision 1007)
+++ trunk/source/processes/hadronic/models/rpg/src/G4RPGNucleonInelastic.cc	(revision 1055)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4RPGNucleonInelastic.cc,v 1.1 2008/01/04 23:28:10 dennis Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4RPGNucleonInelastic.cc,v 1.2 2009/05/25 19:06:03 dennis Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
  
@@ -70,6 +70,30 @@
     }
   }
+  
+  //  printCrossSections();
 
 }
+
+/*
+void G4RPGNucleonInelastic::printCrossSections() const
+{
+  G4cout << " pp total cross sections (mb) " << G4endl;
+  for (G4int i = 0; i < 5; i++) {
+    G4int istart = i*6;
+    G4int istop = istart + 6;
+    for (G4int t = istart; t < istop; t++) G4cout << pPtot[t] << "  " ;
+    G4cout << G4endl;
+  }
+  G4cout << G4endl;
+
+  G4cout << " pn total cross sections (mb) " << G4endl;
+  for (G4int i = 0; i < 5; i++) {
+    G4int istart = i*6;
+    G4int istop = istart + 6;
+    for (G4int t = istart; t < istop; t++) G4cout << pNtot[t] << "  " ;
+    G4cout << G4endl;
+  }
+}
+*/
 
 
Index: trunk/source/processes/hadronic/models/rpg/src/G4RPGPionInelastic.cc
===================================================================
--- trunk/source/processes/hadronic/models/rpg/src/G4RPGPionInelastic.cc	(revision 1007)
+++ trunk/source/processes/hadronic/models/rpg/src/G4RPGPionInelastic.cc	(revision 1055)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4RPGPionInelastic.cc,v 1.1 2008/01/05 00:15:12 dennis Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4RPGPionInelastic.cc,v 1.2 2009/05/25 19:05:47 dennis Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
  
@@ -71,5 +71,30 @@
   }
 
+  //  printCrossSections();
+
 }
+
+
+/*
+void G4RPGPionInelastic::printCrossSections() const
+{
+  G4cout << " pi+ p total cross sections (mb) " << G4endl;
+  for (G4int i = 0; i < 5; i++) {
+    G4int istart = i*6;
+    G4int istop = istart + 6;
+    for (G4int t = istart; t < istop; t++) G4cout << pipPtot[t] << "  " ;
+    G4cout << G4endl;
+  }
+  G4cout << G4endl;
+
+  G4cout << " pi- p total cross sections (mb) " << G4endl;
+  for (G4int i = 0; i < 5; i++) {
+    G4int istart = i*6;
+    G4int istop = istart + 6;
+    for (G4int t = istart; t < istop; t++) G4cout << pimPtot[t] << "  " ;
+    G4cout << G4endl;
+  }
+}
+*/
 
 
Index: trunk/source/processes/hadronic/models/theo_high_energy/History
===================================================================
--- trunk/source/processes/hadronic/models/theo_high_energy/History	(revision 1007)
+++ trunk/source/processes/hadronic/models/theo_high_energy/History	(revision 1055)
@@ -14,4 +14,8 @@
      * Please list in reverse chronological order (last date on top)
      ---------------------------------------------------------------
+
+29-Apr-2009 M.Kosov         had-theo-HE-V09-02-02
+- Quasi Elastic part is made more used in QGSC at low energies to improve
+  the performance of QGSC at low energies
 
 8-Apr-2008  G.Folger        had-theo-HE-V09-01-01
Index: trunk/source/processes/hadronic/models/theo_high_energy/src/G4QuasiElasticChannel.cc
===================================================================
--- trunk/source/processes/hadronic/models/theo_high_energy/src/G4QuasiElasticChannel.cc	(revision 1007)
+++ trunk/source/processes/hadronic/models/theo_high_energy/src/G4QuasiElasticChannel.cc	(revision 1055)
@@ -25,9 +25,10 @@
 //
 //
-// $Id: G4QuasiElasticChannel.cc,v 1.4 2008/04/24 13:26:19 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4QuasiElasticChannel.cc,v 1.7 2009/04/09 08:28:42 mkossov Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 
 // Author : Gunter Folger March 2007
+// Modified by Mikhail Kossov. Apr2009, E/M conservation: ResidualNucleus is added (ResNuc)
 // Class Description
 // Final state production model for theoretical models of hadron inelastic
@@ -42,5 +43,5 @@
 
 
-#include "G4HadTmpUtil.hh"		//lrint
+#include "G4HadTmpUtil.hh"  //lrint
 
 //#define debug_scatter
@@ -48,5 +49,5 @@
 G4QuasiElasticChannel::G4QuasiElasticChannel()
 {
-	theQuasiElastic=G4QuasiFreeRatios::GetPointer();
+ theQuasiElastic=G4QuasiFreeRatios::GetPointer();
 }
 
@@ -55,83 +56,129 @@
 
 G4double G4QuasiElasticChannel::GetFraction(G4Nucleus &theNucleus,
-				const G4DynamicParticle & thePrimary)
+    const G4DynamicParticle & thePrimary)
 {
-	std::pair<G4double,G4double> ratios;
-	ratios=theQuasiElastic->GetRatios(thePrimary.GetTotalMomentum(),
-			thePrimary.GetDefinition()->GetPDGEncoding(),
-			G4lrint(theNucleus.GetZ()),
-			G4lrint(theNucleus.GetN()-theNucleus.GetZ()));
-#ifdef debug_getFraction			
-	G4cout << "G4QuasiElasticChannel::ratios " << ratios.first << " x " <<ratios.second
-	       << "  = " << ratios.first*ratios.second << G4endl;
+  std::pair<G4double,G4double> ratios;
+#ifdef debug_scatter   
+  G4cout << "G4QuasiElasticChannel:: P=" << thePrimary.GetTotalMomentum()
+         << ", pPDG=" << thePrimary.GetDefinition()->GetPDGEncoding()
+         << ", Z = "  << G4lrint(theNucleus.GetZ())
+         << ", N = "  << G4lrint(theNucleus.GetN()-theNucleus.GetZ()) << G4endl;
 #endif
-	       
-	return ratios.first*ratios.second;       		
+  ratios=theQuasiElastic->GetRatios(thePrimary.GetTotalMomentum(),
+                                    thePrimary.GetDefinition()->GetPDGEncoding(),
+                                    G4lrint(theNucleus.GetZ()),
+                                    G4lrint(theNucleus.GetN()-theNucleus.GetZ()));
+#ifdef debug_scatter   
+  G4cout << "G4QuasiElasticChannel::ratios " << ratios.first << " x " <<ratios.second
+         << "  = " << ratios.first*ratios.second << G4endl;
+#endif
+        
+  return ratios.first*ratios.second;
+  //return 0.; // Switch off quasielastic (temporary) M.K.
+  //return 1.; // Only quasielastic (temporary) M.K. (DANGEROSE! Crashes at A=1!)
 }
 
 G4KineticTrackVector * G4QuasiElasticChannel::Scatter(G4Nucleus &theNucleus,
-					const G4DynamicParticle & thePrimary)
+                                                      const G4DynamicParticle & thePrimary)
 {
-	
-	
-	G4int A=G4lrint(theNucleus.GetN());
-//	G4int Z=G4lrint(theNucleus.GetZ());
-//   build Nucleus and choose random nucleon to scatter with
-	the3DNucleus.Init(theNucleus.GetN(),theNucleus.GetZ());
-	const std::vector<G4Nucleon *> nucleons=the3DNucleus.GetNucleons();
-	
-        G4int index;
-        do {
-	   index=G4lrint((A-1)*G4UniformRand());
-	   
-	} while (index < 0 || index >= static_cast<G4int>(nucleons.size()));
-	    
-//	G4double an=G4UniformRand()*A;
-	G4ParticleDefinition * pDef= nucleons[index]->GetDefinition();
-	
+  G4int A=G4lrint(theNucleus.GetN());
+  G4int Z=G4lrint(theNucleus.GetZ());                                 // M.K. ResNuc
+  //   build Nucleus and choose random nucleon to scatter with
+  the3DNucleus.Init(theNucleus.GetN(),theNucleus.GetZ());
 #ifdef debug_scatter
-	G4cout << " neutron - proton? A, Z, an, pdg" <<" "
-	       << A <<" "<<G4lrint(theNucleus.GetZ())
-	       << " "<<an <<" " << pDef->GetParticleName()<< G4endl;
+  G4cout<<"G4QElC::Scat: Before GetNucleons " << G4endl;
 #endif
-//	G4LorentzVector pNucleon(G4ThreeVector(0,0,0),pDef->GetPDGMass());
-	G4LorentzVector pNucleon=nucleons[index]->Get4Momentum();
-	
-	std::pair<G4LorentzVector,G4LorentzVector> result;
-	
-	result=theQuasiElastic->Scatter(pDef->GetPDGEncoding(),pNucleon,
-	                       thePrimary.GetDefinition()->GetPDGEncoding(),
-			        thePrimary.Get4Momentum());
-				
-	if (result.first.e() == 0.)
-	{
-	   G4cout << "Warning - G4QuasiElasticChannel::Scatter no scattering" << G4endl;
-	   return 0;       //no scatter
-	}
+  const std::vector<G4Nucleon *> nucleons=the3DNucleus.GetNucleons();
+  G4double targetNucleusMass=the3DNucleus.GetMass();                  // M.K. ResNuc
+#ifdef debug_scatter
+  G4cout<<"G4QElC::Scat: targetMass = " << targetNucleusMass << G4endl;
+#endif
+  G4LorentzVector targetNucleus4Mom(0.,0.,0.,targetNucleusMass);      // M.K. ResNuc
+  G4int index;
+  do
+  {
+    index=G4lrint((A-1)*G4UniformRand());
+  } while (index < 0 || index >= static_cast<G4int>(nucleons.size()));
+#ifdef debug_scatter
+  G4cout<<"G4QElC::Scat: index = " << index << G4endl;
+#endif
+  G4ParticleDefinition * pDef= nucleons[index]->GetDefinition();
+  G4int resA=A-1;                                                     // M.K. ResNuc
+  G4int resZ=Z-static_cast<int>(pDef->GetPDGCharge());                // M.K. ResNuc
+  G4ParticleDefinition* resDef=G4Neutron::Neutron(); // Resolve t-p=nn problem M.K. ResNuc
+  G4double residualNucleusMass=resDef->GetPDGMass();                  // M.K. ResNuc
+  if(resZ)
+  {
+    resDef=G4ParticleTable::GetParticleTable()->FindIon(resZ,resA,0,resZ);// M.K. ResNuc
+    residualNucleusMass=resDef->GetPDGMass();                         // M.K. ResNuc
+  }
+  else residualNucleusMass*=resA;                           // resA=resN M.K. ResNuc 
+#ifdef debug_scatter
+  G4cout<<"G4QElChan::Scatter: neutron - proton? A ="<<A<<", Z="<<Z<<", projName="
+        <<pDef->GetParticleName()<<G4endl;
+#endif
+  // G4LorentzVector pNucleon(G4ThreeVector(0,0,0),pDef->GetPDGMass());
+  G4LorentzVector pNucleon=nucleons[index]->Get4Momentum();
+  G4double residualNucleusEnergy=std::sqrt(residualNucleusMass*residualNucleusMass+
+                                           pNucleon.vect().mag2());   // M.K. ResNuc
+  pNucleon.setE(targetNucleusMass-residualNucleusEnergy);             // M.K. ResNuc
+  G4LorentzVector residualNucleus4Mom=targetNucleus4Mom-pNucleon;     // M.K. ResNuc
+ 
+  std::pair<G4LorentzVector,G4LorentzVector> result;
+ 
+  result=theQuasiElastic->Scatter(pDef->GetPDGEncoding(),pNucleon,
+                                  thePrimary.GetDefinition()->GetPDGEncoding(),
+  thePrimary.Get4Momentum());
+  G4LorentzVector scatteredHadron4Mom=result.second;                  // M.K. ResNuc
+  if (result.first.e() <= 0.)
+  {
+    //G4cout << "Warning - G4QuasiElasticChannel::Scatter no scattering" << G4endl;
+    //return 0;       //no scatter
+    G4LorentzVector scatteredHadron4Mom=thePrimary.Get4Momentum();   // M.K. ResNuc
+    residualNucleus4Mom=G4LorentzVector(0.,0.,0.,targetNucleusMass); // M.K. ResNuc
+    resDef=G4ParticleTable::GetParticleTable()->FindIon(Z,A,0,Z);    // M.K. ResNuc
+  }
 
 #ifdef debug_scatter
-        G4LorentzVector EpConservation=pNucleon+thePrimary.Get4Momentum() 
-	                                - result.first - result.second;
-	if (   (EpConservation.vect().mag2() > 0.01*MeV*MeV )
-	    || 	(std::abs(EpConservation.e()) > 0.1 * MeV ) ) 
-	{
-	    G4cout << "Warning - G4QuasiElasticChannel::Scatter E-p non conservation : "
-	            << EpConservation << G4endl;
-	}    
+  G4LorentzVector EpConservation=pNucleon+thePrimary.Get4Momentum() 
+                                 - result.first - result.second;
+  if (   (EpConservation.vect().mag2() > .01*MeV*MeV )
+      || (std::abs(EpConservation.e()) > 0.1 * MeV ) ) 
+  {
+    G4cout << "Warning - G4QuasiElasticChannel::Scatter E-p non conservation : "
+           << EpConservation << G4endl;
+  }    
 #endif
 
-	G4KineticTrackVector * ktv;
-	ktv=new G4KineticTrackVector();
-	G4KineticTrack * sPrim=new G4KineticTrack(thePrimary.GetDefinition(),
-			0.,G4ThreeVector(0), result.second);
-	ktv->push_back(sPrim);
-	G4KineticTrack * sNuc=new G4KineticTrack(pDef,
-			0.,G4ThreeVector(0), result.first);
-	ktv->push_back(sNuc);
-	
+  G4KineticTrackVector * ktv;
+  ktv=new G4KineticTrackVector();
+  G4KineticTrack * sPrim=new G4KineticTrack(thePrimary.GetDefinition(),
+                                            0.,G4ThreeVector(0), scatteredHadron4Mom);
+  ktv->push_back(sPrim);
+  if (result.first.e() > 0.)
+  {
+    G4KineticTrack * sNuc=new G4KineticTrack(pDef, 0.,G4ThreeVector(0), result.first);
+    ktv->push_back(sNuc);
+  }
+  if(resZ || resA==1) // For the only neutron or for tnuclei with Z>0    M.K. ResNuc
+  {
+    G4KineticTrack * rNuc=new G4KineticTrack(resDef,
+                           0.,G4ThreeVector(0), residualNucleus4Mom); // M.K. ResNuc
+    ktv->push_back(rNuc);                                             // M.K. ResNuc
+  }
+  else // The residual nucleus consists of only neutrons                 M.K. ResNuc
+  {
+    residualNucleus4Mom/=resA;     // Split 4-mom of A*n system equally  M.K. ResNuc
+    for(G4int in=0; in<resA; in++) // Loop over neutrons in A*n system.  M.K. ResNuc
+    {
+      G4KineticTrack* rNuc=new G4KineticTrack(resDef,
+                           0.,G4ThreeVector(0), residualNucleus4Mom); // M.K. ResNuc
+      ktv->push_back(rNuc);                                           // M.K. ResNuc
+    }
+  }
 #ifdef debug_scatter
-	G4cout << " scattered Nucleon : " << result.first << " mass " <<result.first.mag() << G4endl;
-	G4cout << " scattered Project : " << result.second << " mass " <<result.second.mag() << G4endl;
+  G4cout<<"G4QElC::Scat: Nucleon: "<<result.first <<" mass "<<result.first.mag() << G4endl;
+  G4cout<<"G4QElC::Scat: Project: "<<result.second<<" mass "<<result.second.mag()<< G4endl;
 #endif
-	return ktv;			       
+  return ktv;
 }
Index: trunk/source/processes/hadronic/models/theo_high_energy/src/G4TheoFSGenerator.cc
===================================================================
--- trunk/source/processes/hadronic/models/theo_high_energy/src/G4TheoFSGenerator.cc	(revision 1007)
+++ trunk/source/processes/hadronic/models/theo_high_energy/src/G4TheoFSGenerator.cc	(revision 1055)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4TheoFSGenerator.cc,v 1.9 2007/11/13 16:01:36 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4TheoFSGenerator.cc,v 1.11 2009/04/09 08:28:42 mkossov Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 // G4TheoFSGenerator
@@ -91,5 +91,40 @@
      if ( theQuasielastic->GetFraction(theNucleus, *aPart) > G4UniformRand() )
      {
-        G4KineticTrackVector *result= theQuasielastic->Scatter(theNucleus, *aPart);
+       //G4cout<<"___G4TheoFSGenerator: before Scatter (1) QE=" << theQuasielastic<<G4endl;
+       G4KineticTrackVector *result= theQuasielastic->Scatter(theNucleus, *aPart);
+       //G4cout << "^^G4TheoFSGenerator: after Scatter (1) " << G4endl;
+       if (result)
+       {
+	    for(unsigned int  i=0; i<result->size(); i++)
+	    {
+	      G4DynamicParticle * aNew = 
+		 new G4DynamicParticle(result->operator[](i)->GetDefinition(),
+                        	       result->operator[](i)->Get4Momentum().e(),
+                        	       result->operator[](i)->Get4Momentum().vect());
+	      theParticleChange->AddSecondary(aNew);
+	      delete result->operator[](i);
+	    }
+	    delete result;
+	   
+       } else 
+       {
+	    theParticleChange->SetStatusChange(isAlive);
+	    theParticleChange->SetEnergyChange(thePrimary.GetKineticEnergy());
+	    theParticleChange->SetMomentumChange(thePrimary.Get4Momentum().vect().unit());
+ 
+       }
+	return theParticleChange;
+     } 
+  }
+  if ( theProjectileDiffraction) {
+  
+     if ( theProjectileDiffraction->GetFraction(theNucleus, *aPart) > G4UniformRand() )
+      // strictly, this returns fraction on inelastic, so quasielastic should 
+	//    already be substracted, ie. quasielastic should always be used
+	//     before diffractive
+     {
+       //G4cout << "____G4TheoFSGenerator: before Scatter (2) " << G4endl;
+       G4KineticTrackVector *result= theProjectileDiffraction->Scatter(theNucleus, *aPart);
+       //G4cout << "^^^^G4TheoFSGenerator: after Scatter (2) " << G4endl;
 	if (result)
 	{
@@ -115,39 +150,8 @@
      } 
   }
-  if ( theProjectileDiffraction) {
-  
-     if ( theProjectileDiffraction->GetFraction(theNucleus, *aPart) > G4UniformRand() )
-        // strictly, this returns fraction on inelastic, so quasielastic should 
-	//    already be substracted, ie. quasielastic should always be used
-	//     before diffractive
-     {
-        G4KineticTrackVector *result= theProjectileDiffraction->Scatter(theNucleus, *aPart);
-	if (result)
-	{
-	    for(unsigned int  i=0; i<result->size(); i++)
-	    {
-	      G4DynamicParticle * aNew = 
-		 new G4DynamicParticle(result->operator[](i)->GetDefinition(),
-                        	       result->operator[](i)->Get4Momentum().e(),
-                        	       result->operator[](i)->Get4Momentum().vect());
-	      theParticleChange->AddSecondary(aNew);
-	      delete result->operator[](i);
-	    }
-	    delete result;
-	   
-	} else 
-	{
-	    theParticleChange->SetStatusChange(isAlive);
-	    theParticleChange->SetEnergyChange(thePrimary.GetKineticEnergy());
-	    theParticleChange->SetMomentumChange(thePrimary.Get4Momentum().vect().unit());
- 
-	}
-	return theParticleChange;
-     } 
-  }
-
+  //G4cout << "____G4TheoFSGenerator: before Scatter (3) " << G4endl;
   G4KineticTrackVector * theInitialResult =
                theHighEnergyGenerator->Scatter(theNucleus, *aPart);
-  
+  //G4cout << "^^^^G4TheoFSGenerator: after Scatter (3) " << G4endl;
   
   G4ReactionProductVector * theTransportResult = NULL;
Index: trunk/source/processes/hadronic/processes/History
===================================================================
--- trunk/source/processes/hadronic/processes/History	(revision 1007)
+++ trunk/source/processes/hadronic/processes/History	(revision 1055)
@@ -1,4 +1,4 @@
 -------------------------------------------------------------------
-$Id: History,v 1.5 2008/10/02 20:40:16 dennis Exp $
+$Id: History,v 1.6 2009/03/31 19:16:38 vnivanch Exp $
 -------------------------------------------------------------------
 
@@ -16,4 +16,11 @@
      * Please list in reverse chronological order (last date on top)
      ---------------------------------------------------------------
+
+31 Mar 2009 Vladimir Ivanchenko (hadr-proc-V09-02-00)
+----------------------------------------------------
+- To fix bug #1056 cross section data set now are created by new in
+  G4PhotoNuclearProcess, G4ElectronNuclearProcess, and 
+  G4PositronNuclearProcess. For the last class inline constructor 
+  and destructors moved to source 
 
 2 Oct 2008 Dennis Wright (hadr-proc-V09-01-02)
Index: trunk/source/processes/hadronic/processes/include/G4ElectronNuclearProcess.hh
===================================================================
--- trunk/source/processes/hadronic/processes/include/G4ElectronNuclearProcess.hh	(revision 1007)
+++ trunk/source/processes/hadronic/processes/include/G4ElectronNuclearProcess.hh	(revision 1055)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4ElectronNuclearProcess.hh,v 1.5 2006/06/29 21:02:17 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4ElectronNuclearProcess.hh,v 1.6 2009/03/31 19:16:38 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 // Class Description:
@@ -42,18 +42,13 @@
  
 #include "G4HadronInelasticProcess.hh"
-#include "G4ElectroNuclearCrossSection.hh"
  
+class G4ElectronNuclearProcess : public G4HadronInelasticProcess
+{
+public:
+    
+  G4ElectronNuclearProcess( const G4String& processName = "ElectroNuclear" );
+  virtual ~G4ElectronNuclearProcess();
 
- class G4ElectronNuclearProcess : public G4HadronInelasticProcess
- {
- public:
-    
-    G4ElectronNuclearProcess( const G4String& processName = "ElectroNuclear" );
-    ~G4ElectronNuclearProcess();
-
- private:
- 
-   G4ElectroNuclearCrossSection theData;
- };
+};
 
 #endif
Index: trunk/source/processes/hadronic/processes/include/G4PhotoNuclearProcess.hh
===================================================================
--- trunk/source/processes/hadronic/processes/include/G4PhotoNuclearProcess.hh	(revision 1007)
+++ trunk/source/processes/hadronic/processes/include/G4PhotoNuclearProcess.hh	(revision 1055)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4PhotoNuclearProcess.hh,v 1.8 2007/01/07 04:56:01 dennis Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4PhotoNuclearProcess.hh,v 1.9 2009/03/31 19:16:38 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 // Class Description
@@ -40,18 +40,13 @@
  
 #include "G4HadronInelasticProcess.hh"
-#include "G4PhotoNuclearCrossSection.hh"
  
+class G4PhotoNuclearProcess : public G4HadronInelasticProcess
+{
+public:
+    
+  G4PhotoNuclearProcess( const G4String& processName = "PhotonInelastic" );
+  virtual ~G4PhotoNuclearProcess();
 
- class G4PhotoNuclearProcess : public G4HadronInelasticProcess
- {
- public:
-    
-    G4PhotoNuclearProcess( const G4String& processName = "PhotonInelastic" );
-    ~G4PhotoNuclearProcess();
-
- private:
- 
-   G4PhotoNuclearCrossSection theData;
- };
+};
 
 #endif
